# dmraid is deprecated
%define configure_opts --without-dmraid

Name:    libblockdev
Version: 2.24
Release: 2
Summary: libblockdev is a C library supporting GObject introspection for manipulation of block devices
License: LGPLv2+
URL:     https://github.com/storaged-project/libblockdev
Source0: https://github.com/storaged-project/libblockdev/releases/download/%{version}-1/%{name}-%{version}.tar.gz

BuildRequires: git glib2-devel libyaml-devel libbytesize-devel parted-devel libuuid-devel ndctl-devel device-mapper-devel
BuildRequires: device-mapper-devel systemd-devel nss-devel volume_key-devel >= 0.3.9-7 libblkid-devel libmount-devel
BuildRequires: cryptsetup-devel kmod-devel libxslt glib2-doc gtk-doc python2-devel python3-devel gobject-introspection-devel
BuildRequires: autoconf-archive 
Requires:      btrfs-progs device-mapper device-mapper-multipath lvm2 mdadm
Requires:      device-mapper-persistent-data lvm2-dbusd >= 2.02.156 ndctl gdisk util-linux
Recommends:    vdo kmod-kvdo

Provides:  %{name}-utils%{?_isa} %{name}-utils
Obsoletes: %{name}-utils
Provides:  %{name}-btrfs%{?_isa} %{name}-btrfs
Obsoletes: %{name}-btrfs
Provides:  %{name}-crypto%{?_isa} %{name}-crypto
Obsoletes: %{name}-crypto
Provides:  %{name}-dm%{?_isa} %{name}-dm
Obsoletes: %{name}-dm
Provides:  %{name}-fs%{?_isa} %{name}-fs
Obsoletes: %{name}-fs
Provides:  %{name}-kbd%{?_isa} %{name}-kbd
Obsoletes: %{name}-kbd
Provides:  %{name}-vdo%{?_isa} %{name}-vdo
Obsoletes: %{name}-vdo
Provides:  %{name}-loop%{?_isa} %{name}-loop
Obsoletes: %{name}-loop
Provides:  %{name}-lvm%{?_isa} %{name}-lvm
Obsoletes: %{name}-lvm
Provides:  %{name}-lvm-dbus%{?_isa} %{name}-lvm-dbus
Obsoletes: %{name}-lvm-dbus
Provides:  %{name}-mdraid%{?_isa} %{name}-mdraid
Obsoletes: %{name}-mdraid
Provides:  %{name}-mpath%{?_isa} %{name}-mpath
Obsoletes: %{name}-mpath
Provides:  %{name}-nvdimm%{?_isa} %{name}-nvdimm
Obsoletes: %{name}-nvdimm
Provides:  %{name}-part%{?_isa} %{name}-part
Obsoletes: %{name}-part
Provides:  %{name}-swap%{?_isa} %{name}-swap
Obsoletes: %{name}-swap
Provides:  %{name}-plugins-all%{?_isa} %{name}-plugins-all
Obsoletes: %{name}-plugins-all

%description
libblockdev is a C library supporting GObject introspection for manipulation of block devices.
It has a plugin-based architecture where each technology (like LVM, Btrfs, MD RAID, Swap,...) is implemented in a separate plugin,
possibly with multiple implementations (e.g. using LVM CLI or the new LVM DBus API).

%package devel
Summary: Libraries and header files for libblockdev
Requires: %{name}%{?_isa} = %{version}-%{release}
Requires: glib2-devel device-mapper-devel xfsprogs dosfstools systemd-devel

Provides:  %{name}-btrfs-devel%{?_isa} %{name}-btrfs-devel
Obsoletes: %{name}-btrfs-devel
Provides:  %{name}-crypto-devel%{?_isa} %{name}-crypto-devel
Obsoletes: %{name}-crypto-devel
Provides:  %{name}-dm-devel%{?_isa} %{name}-dm-devel
Obsoletes: %{name}-dm-devel
Provides:  %{name}-fs-devel%{?_isa} %{name}-fs-devel
Obsoletes: %{name}-fs-devel
Provides:  %{name}-kbd-devel%{?_isa}  %{name}-kbd-devel
Obsoletes: %{name}-kbd-devel
Provides:  %{name}-loop-devel%{?_isa} %{name}-loop-devel
Obsoletes: %{name}-loop-devel
Provides:  %{name}-lvm-devel%{?_isa} %{name}-lvm-devel
Obsoletes: %{name}-lvm-devel
Provides:  %{name}-lvm-dbus-devel%{?_isa} %{name}-lvm-dbus-devel
Obsoletes: %{name}-lvm-dbus-devel
Provides:  %{name}-mdraid-devel%{?_isa} %{name}-mdraid-devel
Obsoletes: %{name}-mdraid-devel
Provides:  %{name}-mpath-devel%{?_isa} %{name}-mpath-devel
Obsoletes: %{name}-mpath-devel
Provides:  %{name}-nvdimm-devel%{?_isa} %{name}-nvdimm-devel
Obsoletes: %{name}-nvdimm-devel
Provides:  %{name}-part-devel%{?_isa} %{name}-part-devel
Obsoletes: %{name}-part-devel
Provides:  %{name}-swap-devel%{?_isa} %{name}-swap-devel
Obsoletes: %{name}-swap-devel
Provides:  %{name}-vdo-devel%{?_isa} %{name}-vdo-devel
Obsoletes: %{name}-vdo-devel
Provides:  %{name}-utils-devel%{?_isa} %{name}-utils-devel
Obsoletes: %{name}-utils-devel

%description devel
Libraries and header files for a set for utils(libblockdev,libblockdev-btrfs,libblockdev-crypto,
libblockdev-dm,libblockdev-fs,libblockdev-kbd,libblockdev-loop,libblockdev-lvm,
libblockdev-lvm-dbus,libblockdev-mdraid,libblockdev-mpath,libblockdev-nvdimm,libblockdev-part,
libblockdev-swap,libblockdev-utils,libblockdev-vdo

%package tools
Summary:    Various nice tools based on libblockdev
Requires:   %{name}
Requires:   %{name}-lvm
BuildRequires: libbytesize-devel
Recommends: %{name}-lvm-dbus

%description tools
Various nice storage-related tools based on libblockdev.

%package -n python2-blockdev
Summary: Python2 bindings for libblockdev
Requires: %{name}%{?_isa} = %{version}-%{release}
Requires: python2-gobject-base
%{?python_provide:%python_provide python2-blockdev}

%description -n python2-blockdev
Python2 bindings for libblockdev

%package -n python3-blockdev
Summary: Python3 bindings for libblockdev
Requires: %{name}%{?_isa} = %{version}-%{release}
Requires: python3-gobject-base
%{?python_provide:%python_provide python3-blockdev}

%description -n python3-blockdev
Python3 bindings for libblockdev

%prep
%autosetup -n %{name}-%{version} -p1 -Sgit

%build
autoreconf -ivf
%configure %{?configure_opts}
%make_build

%install
%make_install
find %{buildroot} -type f -name "*.la" | xargs %{__rm}

%ldconfig_scriptlets

%files
%license LICENSE
%{_libdir}/libblockdev.so.*
%{_libdir}/girepository*/BlockDev*.typelib
%{_libdir}/libbd_*.so.*
%dir %{_sysconfdir}/libblockdev
%dir %{_sysconfdir}/libblockdev/conf.d
%config %{_sysconfdir}/libblockdev/conf.d/00-default.cfg
%config %{_sysconfdir}/libblockdev/conf.d/10-lvm-dbus.cfg

%files devel
%doc features.rst specs.rst
%{_libdir}/libbd_*.so
%{_libdir}/libblockdev.so
%{_libdir}/pkgconfig/*.pc
%{_datadir}/gtk-doc/html/libblockdev
%{_datadir}/gir*/BlockDev*.gir
%dir %{_includedir}/blockdev
%{_includedir}/blockdev/*

%files tools
%{_bindir}/lvm-cache-stats

%files -n python2-blockdev
%{python2_sitearch}/gi/overrides/*

%files -n python3-blockdev
%{python3_sitearch}/gi/overrides/*


%changelog
* Wed Jan 6 2021 Lixiaokeng <lixiaokeng@huawei.com> - 2.24-2
- remove require of dmraid

* Wed Jul 29 2020 Zhiqiang Liu <liuzhiqiang26@huawei.com> - 2.24-1
- update to 2.24 version

* Mon Sep 16 2019 wubo<wubo40@huawei.com> - 2.20.4
- Package init
